' John Conway's Game of Life for Micromite MMBasic with TeraTerm
' Bill McKinley
' Algorithm as revised by Tom Williams
' 3 dimensional array as suggested by TassyJim
'
' NOTE: If you make the matrix too small the Glider demo will cause an error
' and the matrix will not overwrite some of the text on the screen
' Make it too big and it will not fit on the screen
' A ratio of 2 of x to 1 of y gives a better looking display
MatX = 40   ' Matrix horizontal size
MatY = 25   ' Matrix vertical size
RandL = 0.3 ' For the randomizing of life less than =< RandL means there is life
            ' Make it high and you get a lot of cells but they die quickly
PT = 000    ' Pause time in mS between display updates
A$ = "O"    ' The character to display a live cell - X or O are OK 
dim AA$(MatX)

' Zero based matrix has one more cell all round than is displayed
dim CurM(MatX+1, MatY+1, 1) ' The current matrix of life - twice

ChkScr      ' Print intro
SetupTimer  ' Randomize by waiting for a keypress
ClrScr      ' Clear the screen (matrix area)
InitM       ' Initialize the random matrix (or demo)
G2 = 0      ' Just to be sure that it starts with the correct matrix

do          ' Program loop
G2 = 1 - G2 ' Changes 0>1>0... each time around
G1 = 0 = G2
NextGen     ' Calculate the next generation and print the current
pause PT
loop until inkey$ <> "" ' loop until a keypres

sub ChkScr ' Print intro
ClrScr
print "   CONWAY'S GAME OF LIFE"
print
print "   Press a key to start"
print "   and another to stop"
print "   G for a glider demo"
end sub

sub SetupTimer ' Wait for a key press to seed RND() with timer
Do
  E$ = inkey$
loop until E$ <> ""
randomize timer
end sub

sub ClrScr 'Clear the screen
PRINT CHR$(27) "[2J" CHR$(27) "[H"
end sub

sub InitM ' Initialise the matrix of life
if E$ = "g" or E$ = "G" then  'Set thr glider and target
  CurM(4,7,0)=1:CurM(5,7,0)=1:CurM(6,7,0)=1:CurM(6,6,0)=1: CurM(5,5,0)=1
  CurM(15,15,0) =1:CurM(15,16,0)=1:CurM(16,15,0)=1:CurM(16,16,0)=1    
else
for y=1 to MatY
  for x=1 to MatX
    if rnd() =< RandL then CurM(x,y,0) = 1
  next x
next y
end if
end sub

' Removed white space from this sub to (hopefully) gain a few uS
Sub NextGen ' Breed the next generation into the alternate matrix
print CHR$(27) "[H"
 For y=1 To MatY
   b=0
   c=CurM(1,y-1,g1)+CurM(1,y,g1)+CurM(1,y+1,g1)
   s$=Space$(MatX)
   For x=1 To MatX
     d = CurM(x+1,y-1,g1)+CurM(x+1,y,g1)+CurM(x+1,y+1,g1)
     adj=b+c+d
     If CurM(x,y,g1) Then
       Poke Var s$,x,&h4f
       CurM(x,y,g2)=(adj=3) Or (adj=4)
     Else
       CurM(x,y,g2)=(adj=3)
     EndIf
     b=c
     c=d
   Next x
     aa$(y)=s$
 Next y
for i=1 to MatY:print AA$(i):next i
end sub